

CREATE FUNCTION datediff(p_interval character varying, p_datefrom date, p_dateto date) RETURNS integer
    LANGUAGE plpgsql
    AS $$

BEGIN
if p_Interval = 'm' then
return ((date_part('y',p_DateTo) * 12) + date_part('month',p_DateTo))
- ((date_part('y',p_DateFrom) * 12) + date_part('month',p_DateFrom));
elseif p_Interval = 'y' then
return date_part('y',p_DateTo) - date_part('y',p_DateFrom);
else
raise exception 'Datediff: Interval not supported';
return 0;
end if;
END;
$$;




CREATE TABLE taula_inici_sessio_info (
    nom_usuari character varying(20) NOT NULL,
    contrasenya character varying(20),
    pregunta_secreta character varying(50),
    resposta_secreta character varying(20),
    rol character(10),
    CONSTRAINT pk_nom_usuari PRIMARY KEY (nom_usuari)
);




CREATE TABLE taula_opinio (
    missatge character varying(50) NOT NULL,
    data_missatge date NOT NULL,
    nom_usuari character varying(20) NOT NULL,
    CONSTRAINT pk_nom_usuari_missatge PRIMARY KEY (nom_usuari, missatge)
);




CREATE TABLE taula_preferits (
    nom_usuari character varying(20) NOT NULL,
    codi_producte character(8) NOT NULL,
    quantitat integer,
    data_preferit date NOT NULL
);




CREATE TABLE taula_producte (
    codi_producte character(8) NOT NULL,
    titol character varying(50),
    preu numeric,
    descompte character varying(50),
    cantant character varying(50),
    quantitat_disponible integer,
    tipus character varying(50),
    data_publicacio date NOT NULL,
    CONSTRAINT pk_codi_producte PRIMARY KEY (codi_producte)
);




CREATE TABLE taula_resposta (
    data_resposta date NOT NULL,
    missatge_resposta character varying(50),
    nom_usuari_resposta character varying(20) NOT NULL,
    CONSTRAINT pk_nom_usuari_resposta_data PRIMARY KEY (nom_usuari_resposta, data_resposta)
);




CREATE TABLE taula_usuari (
    codi_usuari integer NOT NULL,
    nom_usuari character varying(20),
    nom character varying(20),
    primer_cognom character varying(20),
    segon_cognom character varying(20),
    data_naixement date NOT NULL,
    e_mail character varying(50),
    adreca1 character varying(50),
    adreca2 character varying(50),
    ciutat character varying(50),
    provincia character varying(50),
    targeta_credit character(16),
    tipus_targeta_credit character(25),
    CONSTRAINT pk_codi_usuari PRIMARY KEY (codi_usuari)
);




CREATE TABLE taula_vendes (
    data_venda date NOT NULL,
    codi_producte character(8) NOT NULL,
    quantitat_venda integer,
    preu numeric,
    nom_usuari character varying(20) NOT NULL
);




CREATE TABLE taula_votacio (
    codi_producte character(8) NOT NULL,
    nombre_vots integer,
    CONSTRAINT pk_codi_producte_vots PRIMARY KEY (codi_producte)
);


