

CREATE TABLE taula_inici_sessio_info (
    nom_usuari character varying(20) NOT NULL,
    contrasenya character varying(20),
    pregunta_secreta character varying(50),
    resposta_secreta character varying(20),
    rol character(10)
);


ALTER TABLE public.taula_inici_sessio_info OWNER TO postgres;



CREATE TABLE taula_opinio (
    missatge character varying(50) NOT NULL,
    data_missatge date NOT NULL,
    nom_usuari character varying(20) NOT NULL
);


ALTER TABLE public.taula_opinio OWNER TO postgres;



CREATE TABLE taula_preferits (
    nom_usuari character varying(20) NOT NULL,
    codi_producte character(8) NOT NULL,
    quantitat integer,
    data_preferit date NOT NULL
);


ALTER TABLE public.taula_preferits OWNER TO postgres;



CREATE TABLE taula_producte (
    codi_producte character(8) NOT NULL,
    titol character varying(50),
    preu numeric,
    descompte character varying(50),
    cantant character varying(50),
    quantitat_disponible integer,
    tipus character varying(50),
    data_publicacio date
);


ALTER TABLE public.taula_producte OWNER TO postgres;



CREATE TABLE taula_resposta (
    data_resposta date NOT NULL,
    missatge_resposta character varying(50),
    nom_usuari_resposta character varying(20) NOT NULL
);


ALTER TABLE public.taula_resposta OWNER TO postgres;



CREATE TABLE taula_usuari (
    codi_usuari integer NOT NULL,
    nom_usuari character varying(20),
    nom character varying(20),
    primer_cognom character varying(20),
    segon_cognom character varying(20),
    data_naixement date,
    e_mail character varying(50),
    adreca1 character varying(50),
    adreca2 character varying(50),
    ciutat character varying(50),
    provincia character varying(50),
    targeta_credit character(16),
    tipus_targeta_credit character(25)
);


ALTER TABLE public.taula_usuari OWNER TO postgres;



CREATE TABLE taula_vendes (
    data_venda date NOT NULL,
    codi_producte character(8) NOT NULL,
    quantitat_venda integer,
    preu numeric,
    nom_usuari character varying(20) NOT NULL
);


ALTER TABLE public.taula_vendes OWNER TO postgres;



CREATE TABLE taula_votacio (
    codi_producte character(8) NOT NULL,
    nombre_vots integer
);


ALTER TABLE public.taula_votacio OWNER TO postgres;

ALTER TABLE ONLY taula_producte
    ADD CONSTRAINT pk_codi_producte PRIMARY KEY (codi_producte);



ALTER TABLE ONLY taula_votacio
    ADD CONSTRAINT pk_codi_producte_vots PRIMARY KEY (codi_producte);



ALTER TABLE ONLY taula_usuari
    ADD CONSTRAINT pk_codi_usuari PRIMARY KEY (codi_usuari);




ALTER TABLE ONLY taula_inici_sessio_info
    ADD CONSTRAINT pk_nom_usuari PRIMARY KEY (nom_usuari);




ALTER TABLE ONLY taula_vendes
    ADD CONSTRAINT pk_nom_usuari_data_producte PRIMARY KEY (nom_usuari, data_venda, codi_producte);




ALTER TABLE ONLY taula_opinio
    ADD CONSTRAINT pk_nom_usuari_missatge PRIMARY KEY (nom_usuari, missatge);



ALTER TABLE ONLY taula_preferits
    ADD CONSTRAINT pk_nom_usuari_producte_data PRIMARY KEY (nom_usuari, codi_producte, data_preferit);




ALTER TABLE ONLY taula_resposta
    ADD CONSTRAINT pk_nom_usuari_resposta_data PRIMARY KEY (nom_usuari_resposta, data_resposta);




REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;

