package eMonMusical.flow;

import org.springframework.validation.DataBinder;
import org.springframework.validation.Errors;
import org.springframework.webflow.action.FormAction;
import org.springframework.webflow.execution.Event;
import org.springframework.webflow.execution.RequestContext;

import eMonMusical.domini.Modifica;
import eMonMusical.domini.Producte;
import eMonMusical.servici.GestorProducte;

public class ModificarInfoProducteAction extends FormAction {

	private GestorProducte gestorProducte;

	@SuppressWarnings("deprecation")
	public Event bind(RequestContext context) throws Exception {

		Modifica modif = (Modifica) context.getFlowScope().get("modifica");
		Producte prod = modif.getProducte();

		Object formObject = getFormObject(context);
		DataBinder binder = createBinder(context, formObject);
		doBind(context, binder);

		putFormErrors(context, binder.getErrors());
		
		gestorProducte.actualitzarProducte(prod);
		
		return success();
	}

	private void putFormErrors(RequestContext context, Errors errors) {
		getFormObjectAccessor(context).putFormErrors(errors,
				getFormErrorsScope());
	}

	public void setGestorProducte(GestorProducte gestorProducte) {
		this.gestorProducte = gestorProducte;
	}

	public GestorProducte getGestorProducte() {
		return gestorProducte;
	}

}
