package eMonMusical.flow;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.springframework.webflow.action.FormAction;
import org.springframework.webflow.core.collection.MutableAttributeMap;
import org.springframework.webflow.execution.Event;
import org.springframework.webflow.execution.RequestContext;

import eMonMusical.domini.Modifica;
import eMonMusical.domini.Producte;
import eMonMusical.servici.AlphanumComparator;
import eMonMusical.servici.GestorProducte;

public class MostrarInfoProducteAction extends FormAction {

	private GestorProducte gestorProducte;

	@SuppressWarnings("unchecked")
	public Event setupReferenceData(RequestContext context) throws Exception {
		String codi;
		List<Producte> prods = gestorProducte.getProductes();
		List<String> codis = new ArrayList<String>();

		int i = 0;
		while (i < prods.size()) {
			Producte prod = prods.get(i);
			codi = prod.getCodi();
			codis.add(codi);
			i++;
		}
		
		Collections.sort(codis, new AlphanumComparator());

		MutableAttributeMap requestScope = context.getRequestScope();
		requestScope.put("codis", codis);
		return new Event(this, "success");
	}

	public Event bind(RequestContext context) throws Exception {
		String codi = context.getRequestParameters().get("codi");
		Modifica modif = (Modifica) context.getFlowScope().get("modifica");

		Producte prod = new Producte();
		prod = gestorProducte.getProducte(codi);

		modif.setProducte(prod);

		return success();

	}

	public void setGestorProducte(GestorProducte gestorProducte) {
		this.gestorProducte = gestorProducte;
	}

	public GestorProducte getGestorProducte() {
		return gestorProducte;
	}

}
