package eMonMusical.flow;

import java.util.List;

import org.springframework.webflow.execution.Action;
import org.springframework.webflow.execution.Event;
import org.springframework.webflow.execution.RequestContext;

import eMonMusical.domini.Compra;
import eMonMusical.domini.Producte;
import eMonMusical.servici.GestorProducte;

public class MostrarProductesTipusAction implements Action {

	private GestorProducte gestorProducte;

	@Override
	public Event execute(RequestContext context) throws Exception {
		String tipus = context.getRequestParameters().get("tipus");
		List<Producte> productes = gestorProducte.llegirTipus(tipus);
		Compra compra = (Compra) context.getFlowScope().get("compra");
		int s = productes.size();
		int i = 0;

		while (s > 0) {
			Producte prod = productes.get(i);
			if (prod.getQuantitat() > 0) {
				compra.afegirProducte(prod);
			}
			s--;
			i++;
		}
		return new Event(this, "success");
	}

	public void setGestorProducte(GestorProducte gestorProducte) {
		this.gestorProducte = gestorProducte;
	}

}
