package eMonMusical.flow;

import org.springframework.webflow.execution.Action;
import org.springframework.webflow.execution.Event;
import org.springframework.webflow.execution.RequestContext;

import eMonMusical.domini.Compra;
import eMonMusical.domini.Producte;
import eMonMusical.servici.GestorProducte;

public class MostrarProductesTriatsAction implements Action {

	private GestorProducte gestorProducte;

	@Override
	public Event execute(RequestContext context) throws Exception {
		String[] codis = context.getRequestParameters().getArray("prod.codi");
		Compra compra = (Compra) context.getFlowScope().get("compra1");
		int size = codis.length;
		int i = 0;

		while (size > 0) {
			String codi = codis[i];
			Producte prod = gestorProducte.getProducte(codi);
			compra.afegirProducte(prod);
			size--;
			i++;
		}

		return new Event(this, "success");
	}

	public void setGestorProducte(GestorProducte gestorProducte) {
		this.gestorProducte = gestorProducte;
	}

}
