package eMonMusical.repositori;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.TimeZone;

import org.springframework.jdbc.core.simple.ParameterizedRowMapper;
import org.springframework.jdbc.core.simple.SimpleJdbcDaoSupport;

import eMonMusical.domini.OpiUsuari;
import eMonMusical.domini.Opinio;

public class JdbcOpinioDao extends SimpleJdbcDaoSupport implements OpinioDao {

	@Override
	public List<OpiUsuari> getOpinions() {
		List<OpiUsuari> opis = getSimpleJdbcTemplate()
		.query("SELECT taula_opinio.*,  taula_usuari.e_mail " +
				"FROM taula_opinio, taula_usuari " +
				"WHERE taula_opinio.nom_usuari = taula_usuari.nom_usuari " +
				"ORDER BY taula_opinio.data_missatge desc;", 
				new OpiMapper());
		
		return opis;
	}

	@Override
	public void guardarOpinio(Opinio opinio) throws ParseException {
		logger.info("Guardant opinio de l'usuari " + opinio.getnUsuari());

		Calendar cal = Calendar.getInstance(TimeZone.getDefault());
		Date ara = (Date) cal.getTime();

		getSimpleJdbcTemplate().update(
				"INSERT INTO "
						+ "taula_opinio(missatge, data_missatge, nom_usuari) "
						+ "VALUES (?, ?, ?);", opinio.getMissatge(), ara,
				opinio.getnUsuari());

	}

	private static class OpiMapper implements
			ParameterizedRowMapper<OpiUsuari> {

		public OpiUsuari mapRow(ResultSet rs, int numFila) throws SQLException {
			OpiUsuari opi = new OpiUsuari();
			try {
				String data = rs.getString("data_missatge");
				Date dataNo = new SimpleDateFormat("yyyy-MM-dd").parse(data);
				String dataSi = new SimpleDateFormat("dd-MM-yyyy")
						.format(dataNo);
				opi.setDataMissatge(dataSi);
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			opi.seteMail(rs.getString("e_mail"));
			opi.setMissatge(rs.getString("missatge"));
			opi.setnUsuari(rs.getString("nom_usuari"));
			
			return opi;
		}

	}

}
