package eMonMusical.servici;

import org.springframework.validation.Errors;
import org.springframework.validation.Validator;
import org.apache.commons.validator.EmailValidator;
import org.apache.commons.validator.CreditCardValidator;
import org.apache.commons.validator.DateValidator;

import eMonMusical.domini.Usuari;
import eMonMusical.domini.IniciSessioInfo;

public class RegistrarValidator implements Validator {

	@SuppressWarnings("rawtypes")
	@Override
	public boolean supports(Class arg0) {
		// TODO Auto-generated method stub
		return Usuari.class.equals(arg0);
	}

	@Override
	public void validate(Object obj, Errors errors) {

		Usuari user = (Usuari) obj;
		IniciSessioInfo isi = user.getIsInfo(); 

		CreditCardValidator ccv = new CreditCardValidator();

		if (user.getnUsuari().isEmpty()) {
			errors.rejectValue("nUsuari", "error.registre");
		}
		if (isi.getContrasenya().isEmpty()) {
			errors.rejectValue("isInfo.contrasenya", "error.registre");
		}
		if (isi.getContrasenya().length()<4){
			errors.rejectValue("isInfo.contrasenya", "error.contrasenya");
		}
		if (isi.getPreguntaSecreta().isEmpty()) {
			errors.rejectValue("isInfo.preguntaSecreta", "error.registre");
		}
		if (isi.getRespostaSecreta().isEmpty()) {
			errors.rejectValue("isInfo.respostaSecreta", "error.registre");
		}
		if (user.getnTcredit().isEmpty()) {
			errors.rejectValue("nTcredit", "error.registre");
		}

		if (!ccv.isValid(user.getnTcredit())) {
			errors.rejectValue("nTcredit", "error.targeta");
		}

		if (user.getTipusTcredit().equals("NONE"))
			errors.rejectValue("tipusTcredit", "error.tipusTargeta");

		if (user.getNom().isEmpty()) {
			errors.rejectValue("nom", "error.registre");
		}
		if (user.getpCognom().isEmpty()) {
			errors.rejectValue("pCognom", "error.registre");
		}
		if (user.getsCognom().isEmpty()) {
			errors.rejectValue("sCognom", "error.registre");
		}
		if (user.getdNaixement().isEmpty()) {
			errors.rejectValue("dNaixement", "error.registre");
		}

		if (!DateValidator.getInstance().isValid(user.getdNaixement(),
				"dd/MM/yyyy", false)) {
			errors.rejectValue("dNaixement", "error.data");
		}

		if (!EmailValidator.getInstance().isValid(user.geteMail())) {
			errors.rejectValue("eMail", "error.email");
		}

		if (user.getpAdre().isEmpty()) {
			errors.rejectValue("pAdre", "error.registre");
		}
		if (user.getsAdre().isEmpty()) {
			errors.rejectValue("sAdre", "error.registre");
		}
		if (user.getCiutat().isEmpty()) {
			errors.rejectValue("ciutat", "error.registre");
		}

		if (user.getProvincia().isEmpty()) {
			errors.rejectValue("provincia", "error.registre");
		}

	}

}
