package eMonMusical.web;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.validation.BindException;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.SimpleFormController;

import eMonMusical.domini.Producte;
import eMonMusical.domini.Votacio;
import eMonMusical.servici.GestorProducte;
import eMonMusical.servici.ProducteBean;

public class AfegirProducteController extends SimpleFormController {

	private GestorProducte gestorProducte;

	public AfegirProducteController() {
		setCommandClass(ProducteBean.class);
		setCommandName("producteBean");
	}

	protected Object formBackingObject(HttpServletRequest request)
			throws Exception {

		ProducteBean pb = new ProducteBean();
		pb.setTriar("guardar");

		return pb;
	}

	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {

		ProducteBean prodb = (ProducteBean) command;

		if (prodb.getTriar().equals("guardar")) {
			Producte prod = new Producte();
			prod.setCodi(prodb.getCodi());
			prod.setTitol(prodb.getTitol());
			prod.setPreu(prodb.getPreu());
			prod.setDescompte(prodb.getDescompte());
			prod.setCantant(prodb.getCantant());
			prod.setQuantitat(prodb.getQuantitat());
			prod.setTipus(prodb.getTipus());
			prod.setData(prodb.getData());
			Votacio v = new Votacio();
			v.setCodi(prodb.getCodi());
			v.setNombreVots(0);
			prod.setVotacio(v);

			this.gestorProducte.afegirProducte(prod);

			return new ModelAndView("producteAfegit", "producteBean", prodb);

		} else if (prodb.getTriar().equals("veure")) {
			Producte prod = new Producte();
			try {
				prod = gestorProducte.getProducte(prodb.getCodi());
				prodb.setTitol(prod.getTitol());
				prodb.setPreu(prod.getPreu());
				prodb.setDescompte(prod.getDescompte());
				prodb.setCantant(prod.getCantant());
				prodb.setQuantitat(prod.getQuantitat());
				prodb.setTipus(prod.getTipus());
				prodb.setData(prod.getData());
				return new ModelAndView("producteVeure", "producteBean", prodb);
			} catch (EmptyResultDataAccessException ex) {
				String errada = "No hi ha cap producte amb codi "+ prodb.getCodi()+" a la BD!";
				ModelAndView error = new ModelAndView("errorProd");
				error.addObject("errada", errada);
				return error;
			}
		}
		return null;
		
	}

	public GestorProducte getGestorProducte() {
		return gestorProducte;
	}

	public void setGestorProducte(GestorProducte gestorProducte) {
		this.gestorProducte = gestorProducte;
	}

}
