package eMonMusical.web;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.validation.BindException;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;
import org.springframework.web.servlet.mvc.SimpleFormController;

import eMonMusical.domini.IniciSessioInfo;
import eMonMusical.domini.Usuari;
import eMonMusical.servici.GestorUsuari;

public class EntrarFormController extends SimpleFormController implements
		Controller {

	protected final Log logger = LogFactory.getLog(getClass());

	private GestorUsuari gestorUsuari;

	public GestorUsuari getGestorUsuari() {
		return gestorUsuari;
	}

	public void setGestorUsuari(GestorUsuari gestorUsuari) {
		this.gestorUsuari = gestorUsuari;
	}

	public ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws ServletException {

		IniciSessioInfo isi = (IniciSessioInfo) command;
		String nUsuari = isi.getnUsuari();
		String contrasenya = isi.getContrasenya();
		Usuari usuari = new Usuari();
		IniciSessioInfo admin = new IniciSessioInfo();

		try {
			isi = gestorUsuari.getUsuari(nUsuari);
			String rol = isi.getRol();

			if (rol.contains("usuari")) {
				usuari = gestorUsuari.getUsuari(nUsuari, contrasenya);
				String nom = usuari.getNom();
				request.getSession().setAttribute("nom", nom);
				request.getSession().setAttribute("nUsuari", nUsuari);

				return new ModelAndView("iniciUsuari", "usuari", usuari);
			} else if (rol.contains("admin")) {
				admin = gestorUsuari.getAdmin(nUsuari, contrasenya);
				return new ModelAndView("iniciAdmin", "admin", admin);
			}

			return new ModelAndView("error", "message",
					"Nom d'usuari i/o contrasenya no vlids. "
							+ "Torna a intentar entrar.");

		} catch (EmptyResultDataAccessException ex) {
			return new ModelAndView("error", "message",
					"Nom d'usuari i/o contrasenya no vlids. "
							+ "Torna a intentar entrar.");
		}

	}
}
