package eMonMusical.web;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;
import org.springframework.web.servlet.mvc.SimpleFormController;

import eMonMusical.domini.Usuari;
import eMonMusical.servici.GestorUsuari;

public class EsborrarUserController extends SimpleFormController implements
		Controller {

	protected final Log logger = LogFactory.getLog(getClass());

	private GestorUsuari gestorUsuari;

	public ModelAndView onSubmit(Object command) throws ServletException {
		Usuari user = (Usuari) command;

		logger.info("Esborrant l'usuari: " + user.getnUsuari());

		gestorUsuari.esborrarUsuari(user.getnUsuari());

		return new ModelAndView("usuariEsborrat", "usuari", user);
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	protected Map referenceData(HttpServletRequest request) throws Exception {

		String nUsuari;
		Map referenceData = new HashMap();

		List<Usuari> users = gestorUsuari.getUsuaris();
		Map<String, String> nUsuaris = new LinkedHashMap<String, String>();
		int i = 0;
		while (i < users.size()) {
			Usuari user = users.get(i);
			nUsuari = user.getnUsuari();
			nUsuaris.put(nUsuari, nUsuari);
			i++;
		}
		referenceData.put("usuaris", nUsuaris);
		return referenceData;
	}

	public GestorUsuari getGestorUsuari() {
		return gestorUsuari;
	}

	public void setGestorUsuari(GestorUsuari gestorUsuari) {
		this.gestorUsuari = gestorUsuari;
	}

}
