package eMonMusical.web;

import java.io.IOException;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;
import org.springframework.web.servlet.mvc.SimpleFormController;

import eMonMusical.domini.ProducteVenut;
import eMonMusical.domini.Venda;
import eMonMusical.servici.GestorVendes;

public class InfoVendesMesController extends SimpleFormController implements
		Controller {
	
	protected final Log logger = LogFactory.getLog(getClass());

	private GestorVendes gestorVendes;

	public GestorVendes getGestorVendes() {
		return gestorVendes;
	}

	public void setGestorVendes(GestorVendes gestorVendes) {
		this.gestorVendes = gestorVendes;
	}

	public ModelAndView handleRequest(HttpServletRequest peticio, HttpServletResponse resposta)
    throws ServletException, IOException {

		logger.info("Mirant vendes setmana passada ");

		List<ProducteVenut> vendes = this.gestorVendes.mostrarVendesMesPassat();
		Venda v = new Venda();
		int size = vendes.size();
		int i = 0;
		float granTotal = 0;
		float total = 0;

		while (size > 0) {
			ProducteVenut prod = vendes.get(i);
			v.afegirVendes(prod);
			total = prod.getQuantitat() * prod.getPreu();
			prod.setTotal(total);
			granTotal = granTotal + total;
			size--;
			i++;
		}

		v.setGranTotal(granTotal);

		return new ModelAndView("infVendesMes", "venda", v);
	}


}
