package eMonMusical.web;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;
import org.springframework.web.servlet.mvc.SimpleFormController;

import eMonMusical.domini.ProducteVenut;
import eMonMusical.domini.Venda;
import eMonMusical.servici.GestorVendes;

public class InfoVendesPerDataController extends SimpleFormController implements
		Controller {

	protected final Log logger = LogFactory.getLog(getClass());

	private GestorVendes gestorVendes;

	public GestorVendes getGestorVendes() {
		return gestorVendes;
	}

	public void setGestorVendes(GestorVendes gestorVendes) {
		this.gestorVendes = gestorVendes;
	}

	public ModelAndView onSubmit(Object command) throws ServletException {
		String data = ((Venda) command).getData();

		logger.info("Mirant vendes durant el dia " + data);

		List<ProducteVenut> vendes = this.gestorVendes
				.mostrarVendesPerData(data);
		Venda v = new Venda();
		v.setData(data);
		int size = vendes.size();
		int i = 0;
		float granTotal = 0;
		float total = 0;

		while (size > 0) {
			ProducteVenut prod = vendes.get(i);
			v.afegirVendes(prod);
			total = prod.getQuantitat() * prod.getPreu();
			prod.setTotal(total);
			granTotal = granTotal + total;
			size--;
			i++;
		}

		v.setGranTotal(granTotal);

		return new ModelAndView("vistaVendesDia", "venda", v);
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	protected Map referenceData(HttpServletRequest request) throws Exception {

		Map referenceData = new HashMap();

		List<String> dates = gestorVendes.mostrarDates();
		Map<String, String> mdates = new LinkedHashMap<String, String>();
		int i = 0;
		while (i < dates.size()) {
			mdates.put(dates.get(i), dates.get(i));
			i++;
		}
		referenceData.put("mdates", mdates);
		return referenceData;
	}

}
