package eMonMusical.web;

import java.util.Calendar;
import java.util.TimeZone;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.validation.BindException;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.SimpleFormController;

import eMonMusical.domini.Opinio;
import eMonMusical.servici.GestorOpinio;

public class OpinioController extends SimpleFormController {

	private GestorOpinio gestorOpinio;

	public OpinioController() {
		setCommandClass(Opinio.class);
		setCommandName("opinio");
	}

	@Override
	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {

		Opinio opi = (Opinio) command;

		String missatge = opi.getMissatge();

		String hora;
		Calendar cal = Calendar.getInstance(TimeZone.getDefault());
		String DATE_FORMAT = "yyyy-MM-dd";
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				DATE_FORMAT);
		sdf.setTimeZone(TimeZone.getDefault());
		hora = sdf.format(cal.getTime());

		String ara = hora;

		Opinio opinio = new Opinio();
		opinio.setMissatge(missatge);
		opinio.setnUsuari((String) request.getSession().getAttribute("nUsuari"));
		opinio.setDataMissatge(ara);

		try {
			this.gestorOpinio.guardarOpinio(opinio);

			return new ModelAndView("missatgeExit");
		} catch (org.springframework.dao.DataIntegrityViolationException ex) {
			return new ModelAndView("inici");
		}

	}

	public GestorOpinio getGestorOpinio() {
		return gestorOpinio;
	}

	public void setGestorOpinio(GestorOpinio gestorOpinio) {
		this.gestorOpinio = gestorOpinio;
	}

}
