package eMonMusical.web;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;

import eMonMusical.domini.ProducteComprat;
import eMonMusical.servici.GestorPreferits;

public class PreferitsUsuariController implements Controller {
	
	protected final Log logger = LogFactory.getLog(getClass());
	private GestorPreferits gestorPreferits;

	@Override
	public ModelAndView handleRequest(HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		String nUsuari = (String) request.getSession().getAttribute("nUsuari");
		logger.info("retorna preferits de l'usuari " + nUsuari);

		List<ProducteComprat> productes = new ArrayList<ProducteComprat>();
		productes = this.gestorPreferits.mostrarPreferitsUsuari(nUsuari);

		if (!productes.isEmpty()) {
			return new ModelAndView("preferitsUsuari", "productes", productes);
		} else {
			return new ModelAndView("preferitsBuit");
		}
	}

	public GestorPreferits getGestorPreferits() {
		return gestorPreferits;
	}

	public void setGestorPreferits(GestorPreferits gestorPreferits) {
		this.gestorPreferits = gestorPreferits;
	}


}
