package eMonMusical.web;

import java.text.ParseException;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;
import org.springframework.web.servlet.mvc.SimpleFormController;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import eMonMusical.domini.Producte;
import eMonMusical.domini.Votacio;
import eMonMusical.servici.GestorProducte;

public class VotacioFormController extends SimpleFormController implements
		Controller {
	protected final Log logger = LogFactory.getLog(getClass());

	private GestorProducte gestorProducte;
	

	public ModelAndView onSubmit(Object command) throws ServletException {
		Producte producte = (Producte)command;
		
		List<Producte> productes = gestorProducte.llegirTitol(producte.getTitol());
		
		producte = productes.get(0);
		
		List<Votacio> votacions = gestorProducte.getVotacioCodiList(producte.getCodi());

		Votacio votacio = votacions.get(0);
		int vots = votacio.getNombreVots()+1;
		votacio.setNombreVots(vots);
		producte.setVotacio(votacio);
		
		try {
			gestorProducte.actualitzarProducte(producte);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		gestorProducte.guardarVotacio(votacio);

		logger.info("Posant el producte "+producte);
		
		return new ModelAndView("votarResultat", "producte", producte);
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	protected Map referenceData(HttpServletRequest request) throws Exception {
		
		String tit;
		Map referenceData = new HashMap();
		
		List<Producte> productes = gestorProducte.getProductes();
		Map<String,String> titol = new LinkedHashMap<String,String>();
		int i = 0;
		while(i<productes.size()){
			Producte prod = productes.get(i);
			tit = prod.getTitol();
			titol.put(tit, tit);
			i++;
		}
		referenceData.put("titols", titol);
        return referenceData;
    }



	public GestorProducte getGestorProducte() {
		return gestorProducte;
	}

	public void setGestorProducte(GestorProducte gestorProducte) {
		this.gestorProducte = gestorProducte;
	}
	


}
