package eMonMusical.repositori;

import java.text.ParseException;
import java.util.List;
import org.springframework.test.AbstractTransactionalDataSourceSpringContextTests;
import eMonMusical.domini.Producte;

public class JdbcProducteDaoTests extends AbstractTransactionalDataSourceSpringContextTests{
	
	private ProducteDao producteDao;

    public void setProducteDao(ProducteDao producteDao) {
        this.producteDao = producteDao;
    }

    @Override
    protected String[] getConfigLocations() {
        return new String[] {"classpath:test-context.xml"};
    }

    @Override
    protected void onSetUpInTransaction() throws Exception {
        super.deleteFromTables(new String[] {"taula_inici_sessio_info","taula_opinio",
        		"taula_preferits","taula_producte","taula_resposta","taula_usuari",
        		"taula_vendes","taula_votacio"});
        super.executeSqlScript("file:bd/carregar_dades.sql", true);
    }

    public void testGetProducteList() {
        List<Producte> productes = producteDao.getProducteVotsList();
        assertEquals("nombre equivocat de productes?", 10, productes.size());
    }
  
    public void testGuardarProducte() throws ParseException {
        List<Producte> productes = producteDao.getProducteVotsList();
        for (Producte p : productes) {
            p.setPreu((float) 200.12);
            p.setDescompte("20%");
            p.setQuantitat(9);
            producteDao.actualitzarProducte(p);
        }
        List<Producte> productesActualitzats = producteDao.getProducteVotsList();
        for (Producte p : productesActualitzats) {
            assertEquals("preu equivocat del producte?", Float.valueOf((float) 200.12), p.getPreu());
            assertEquals("descompte equivocat del producte?", "20%", p.getDescompte());
            assertEquals("quantitat equivocada del producte?", 9, p.getQuantitat());
        }
        
    }


}
