package eMonMusical.servici;

import java.util.ArrayList;
import java.util.List;

import eMonMusical.domini.Producte;
import eMonMusical.domini.Votacio;
import eMonMusical.servici.ImplGestorProducte;
import eMonMusical.repositori.EnMemoriaProducteDao;
import eMonMusical.repositori.ProducteDao;


import junit.framework.TestCase;

public class ImplGestorProducteTests extends TestCase {
	
	private ImplGestorProducte gestorProducte;
	private List<Producte> productes;
	
	private static int PRODUCTE_COMPTAR = 2;
	
	private static String CODI_CDROCK = "87654321";
	private static String TITOL_CDROCK = "SMOKE ON THE WATER";
	private static float PREU_CDROCK = 23;
	private static String DESCOMPTE_CDROCK = "bDescompte";
	private static String CANTANT_CDROCK = "DEEP PURPLE";
	private static int QUANTITAT_CDROCK = 8;
	private static String TIPUS_CDROCK = "ROCK";
	@SuppressWarnings("deprecation")
	private static java.sql.Date DATA_EDICIO_CDROCK = new java.sql.Date(1972,8,19);
	private static int VOTS_CDROCK = 6;
	
	private static String CODI_CDCLASSIC = "12348765";
	private static String TITOL_CDCLASSIC = "BACH SONATAS";
	private static float PREU_CDCLASSIC = 25;
	private static String DESCOMPTE_CDCLASSIC = "cDescompte";
	private static String CANTANT_CDCLASSIC = "ITZHAK PERLMAN";
	private static int QUANTITAT_CDCLASSIC = 6;
	private static String TIPUS_CDCLASSIC = "CLASSIC";
	@SuppressWarnings("deprecation")
	private static java.sql.Date DATA_EDICIO_CDCLASSIC = new java.sql.Date(1985,5,23);
	private static int VOTS_CDCLASSIC = 4;

	protected void setUp() throws Exception {
		gestorProducte = new ImplGestorProducte();
		productes = new ArrayList<Producte>();
		
		Producte producte = new Producte();
		Votacio vot = new Votacio();
		producte.setCodi(CODI_CDROCK);
		producte.setTitol(TITOL_CDROCK);
		producte.setPreu(PREU_CDROCK);
		producte.setDescompte(DESCOMPTE_CDROCK);
		producte.setCantant(CANTANT_CDROCK);
		producte.setQuantitat(QUANTITAT_CDROCK);
		producte.setTipus(TIPUS_CDROCK);
		producte.setData(DATA_EDICIO_CDROCK.toString());
		vot.setCodi(producte.getCodi());
		vot.setNombreVots(VOTS_CDROCK);
		producte.setVotacio(vot);
		productes.add(producte);
		
		
		producte = new Producte();
		vot = new Votacio();
		producte.setCodi(CODI_CDCLASSIC);
		producte.setTitol(TITOL_CDCLASSIC);
		producte.setPreu(PREU_CDCLASSIC);
		producte.setDescompte(DESCOMPTE_CDCLASSIC);
		producte.setCantant(CANTANT_CDCLASSIC);
		producte.setQuantitat(QUANTITAT_CDCLASSIC);
		producte.setTipus(TIPUS_CDCLASSIC);
		producte.setData(DATA_EDICIO_CDCLASSIC.toString());
		vot.setCodi(producte.getCodi());
		vot.setNombreVots(VOTS_CDCLASSIC);
		producte.setVotacio(vot);
		productes.add(producte);
		
		ProducteDao producteDao = new EnMemoriaProducteDao(productes);
        gestorProducte.setProducteDao(producteDao);

	}

	public void testGetProductesSenseProductes() {
		gestorProducte = new ImplGestorProducte();
		gestorProducte.setProducteDao(new EnMemoriaProducteDao(null));
		assertNull(gestorProducte.getProductesVots());
	}

	
	public void testGetProductes(){
		List<Producte> productes = gestorProducte.getProductesVots();
		assertNotNull(productes);
		assertEquals(PRODUCTE_COMPTAR, gestorProducte.getProductesVots().size());
		
		Producte producte = productes.get(0);
		assertEquals(CODI_CDROCK, producte.getCodi());
		assertEquals(TITOL_CDROCK, producte.getTitol());
		assertEquals(PREU_CDROCK, producte.getPreu());
		assertEquals(DESCOMPTE_CDROCK, producte.getDescompte());
		assertEquals(CANTANT_CDROCK, producte.getCantant());
		assertEquals(QUANTITAT_CDROCK, producte.getQuantitat());
		assertEquals(TIPUS_CDROCK, producte.getTipus());
		assertEquals(DATA_EDICIO_CDROCK, producte.getData());
		assertEquals(VOTS_CDROCK, producte.getVotacio().getNombreVots());
		
		producte = productes.get(1);
		assertEquals(CODI_CDCLASSIC, producte.getCodi());
		assertEquals(TITOL_CDCLASSIC, producte.getTitol());
		assertEquals(PREU_CDCLASSIC, producte.getPreu());
		assertEquals(DESCOMPTE_CDCLASSIC, producte.getDescompte());
		assertEquals(CANTANT_CDCLASSIC, producte.getCantant());
		assertEquals(QUANTITAT_CDCLASSIC, producte.getQuantitat());
		assertEquals(TIPUS_CDCLASSIC, producte.getTipus());
		assertEquals(DATA_EDICIO_CDCLASSIC, producte.getData());
		assertEquals(VOTS_CDCLASSIC, producte.getVotacio().getNombreVots());
	}


}
